//
//	cpfShell ZbgAbv
//
#include <windows.h>
#include <windowsx.h>
#include <winuser.h>
#include <shlobj.h>

#include "resource.h"

// NXID {76F7FE62-BCEE-11d5-96CD-444553540000}
#define CLASS_ID "{76F7FE62-BCEE-11d5-96CD-444553540000}"

//const int CSIDL_PROGRAM_FILES = 0x26;
const char *CPFSHELL_NAME = "cpfShell";
const char *CPFUNINSTALL_NAME = "uncpfs.exe";
const char *CPFSHELL_REG = "Software\\nanshiki\\cpfShell";
const char *REG_EXP = "regexp";
const char *CORPORATION = "Nanshiki Corporation";
const char *URL = "http://www.nanshiki.co.jp/";
const int ZIP_COUNT = 3;

char install_path[MAX_PATH];
char dll_path[MAX_PATH];
int regexp_mode;

BOOL APIENTRY MainFunc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL install(HWND hDlg);

//
//	Windows7 ǂ̔
//
BOOL CheckWindows7()
{
    OSVERSIONINFO osvi;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if((osvi.dwMajorVersion == 6 && osvi.dwMinorVersion >= 1) || osvi.dwMajorVersion > 6) {
			return TRUE;
		}
	}
	return FALSE;
}
//
//	64bit OS ǂ̔
//
typedef BOOL (WINAPI *funcIsWow64Process)(HANDLE, PBOOL); 
BOOL IsWow64()
{
	BOOL flag = FALSE;

	funcIsWow64Process pIsWow64Process = (funcIsWow64Process)GetProcAddress(GetModuleHandle("kernel32"), "IsWow64Process");
	if(NULL != pIsWow64Process) {
		pIsWow64Process(GetCurrentProcess(), &flag);
	}
	return flag;
}

BOOL CheckWindowsNT()
{
    OSVERSIONINFO osvi;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		return TRUE;
	}
	return FALSE;
}

//
// tH_xɍ쐬
//	in: path .. 쐬tH_
//
void force_directories(const char *path)
{
	int pos, max;
	char dir[MAX_PATH];
	unsigned char ch;
	BOOL flag = FALSE;

	pos = 0;
	max = lstrlen(path);
	while(pos < max) {
		if(!flag) {
			ch = *(unsigned char *)(path + pos);
		    if(((ch >= 0x81) && (ch <= 0x9f)) || ((ch >= 0xe0) && (ch <= 0xfc))) {
				flag = TRUE;
			} else if(ch == '\\') {
				dir[pos] = '\0';
				CreateDirectory(dir, NULL);
			}
		} else {
			flag = FALSE;
		}
		dir[pos] = *(path + pos);
		pos++;
	}
	CreateDirectory(path, NULL);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszArgs, int nWinMode)
{
	if(IsWow64()) {
		MessageBox(NULL, "cpfShell  64bit OS ł͓삵܂B", "cpfSetup CXg[", MB_OK | MB_ICONERROR);
	} else {
		if(DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_CPFSETUP), GetDesktopWindow(), (DLGPROC)MainFunc) == IDOK) {
			// CXg[
			install(GetDesktopWindow());
		}
	}
	return 0;
}

//
//	_CAObZ[W
//
BOOL APIENTRY MainFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch(message) {
	case WM_INITDIALOG:
		{
			HWND hCtrl;
			char path[MAX_PATH];

			if(CheckWindowsNT()) {
				SHGetSpecialFolderPath(NULL, path, CSIDL_PROGRAM_FILES, TRUE);
			} else {
				char temp[MAX_PATH];
				GetWindowsDirectory(temp, MAX_PATH);
				wsprintf(path, "%c:\\Program Files", temp[0]);
			}
			wsprintf(install_path, "%s\\nanshiki\\%s", path, CPFSHELL_NAME);
			hCtrl = GetDlgItem(hDlg, IDC_EDIT_FOLDER);
			SetWindowText(hCtrl, install_path);
		}
		break;

	case WM_COMMAND:
		switch(LOWORD (wParam)) {
		case IDOK:
			{
				regexp_mode = Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_REGEXP));
				GetWindowText(GetDlgItem(hDlg, IDC_EDIT_FOLDER), install_path, MAX_PATH);
				EndDialog(hDlg, IDOK);
			}
			break;
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			break;
		case IDC_BUTTON_FOLDER:
			{
				BROWSEINFO bri;
				LPITEMIDLIST lpid;

				ZeroMemory(&bri, sizeof(BROWSEINFO));
				bri.hwndOwner = hDlg;
				bri.lpszTitle = "CXg[tH_IĂ";
				bri.pidlRoot = NULL;
				bri.lpfn = NULL;
				bri.ulFlags = BIF_RETURNONLYFSDIRS;
				if(lpid = SHBrowseForFolder(&bri)) {
					SHGetPathFromIDList(lpid, install_path);
					CoTaskMemFree(lpid);
					SetWindowText(GetDlgItem(hDlg, IDC_EDIT_FOLDER), install_path);
				}
			}
			break;
		}
		break;
	}
	return FALSE;
}

extern int unzip_memory(char *buff, const TCHAR *out_path);

bool ExtractZip()
{
	HRSRC hr;
	HGLOBAL hg;
	char *data;
	DWORD wsize;

	// {vO\[XǂݏoWJ
	hr = FindResource(NULL, TEXT("PROG_DATA"), TEXT("ZIP"));
	wsize = SizeofResource(NULL, hr);
	hg = LoadResource(NULL, hr);
	data = (char *)LockResource(hg);
	if(unzip_memory(data, install_path) == ZIP_COUNT) {
		return true;
	}
	return false;
}

//
//	CXg[
//
int install(HWND hDlg)
{
    HKEY hKey, hSubKey;
	DWORD dw;
	char name[1000];

	force_directories(install_path);
	if(ExtractZip()) {
		wsprintf(dll_path, "%s\\%s.DLL", install_path, CPFSHELL_NAME);
		// VFgp̃WXgo^(NX ID)
		wsprintf(name, "CLSID\\%s", CLASS_ID);
   		if(RegCreateKeyEx(HKEY_CLASSES_ROOT, name, 0, "", REG_OPTION_NON_VOLATILE, KEY_CREATE_SUB_KEY, NULL, &hKey, &dw) == ERROR_SUCCESS) {
			RegSetValueEx(hKey, NULL, 0, REG_SZ, (unsigned char *)CPFSHELL_NAME, lstrlen(CPFSHELL_NAME));
			if(RegCreateKeyEx(hKey, "InprocServer32", 0, "", REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hSubKey, &dw) == ERROR_SUCCESS) {
				RegSetValueEx(hSubKey, NULL, 0, REG_SZ, (unsigned char *)dll_path, lstrlen(dll_path));
				RegSetValueEx(hSubKey, "ThreadingModel", 0, REG_SZ, (unsigned char *)"Apartment", lstrlen("Apartment"));
				RegCloseKey(hSubKey);
			}
			RegCloseKey(hKey);

			// VFgp̃WXgo^(SĂ̊gqj
			wsprintf(name, "*\\shellex\\ContextMenuHandlers\\%s", CPFSHELL_NAME);
			if(RegCreateKeyEx(HKEY_CLASSES_ROOT, name, 0, "", REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, &dw) == ERROR_SUCCESS) {
				RegSetValueEx(hKey, NULL, 0, REG_SZ, (unsigned char *)CLASS_ID, lstrlen(CLASS_ID));
				RegCloseKey(hKey);
			}
			// VFgp̃WXgo^(tH_)
			wsprintf(name, "Folder\\shellex\\ContextMenuHandlers\\%s", CPFSHELL_NAME);
			if(RegCreateKeyEx(HKEY_CLASSES_ROOT, name, 0, "", REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, &dw) == ERROR_SUCCESS) {
				RegSetValueEx(hKey, NULL, 0, REG_SZ, (unsigned char *)CLASS_ID, lstrlen(CLASS_ID));
				RegCloseKey(hKey);
			}

			// ACXg[p̐ݒWXgo^
			wsprintf(name, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\%s", CPFSHELL_NAME);
			if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, name, 0, "", REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, &dw) == ERROR_SUCCESS) {
				RegSetValueEx(hKey, "DisplayName", 0, REG_SZ, (unsigned char *)CPFSHELL_NAME, lstrlen(CPFSHELL_NAME));
				wsprintf(name, "%s\\%s", install_path, CPFUNINSTALL_NAME);
				RegSetValueEx(hKey, "DisplayIcon", 0, REG_SZ, (unsigned char *)name, lstrlen(name));
				lstrcat(name, " uninstall");
				RegSetValueEx(hKey, "UninstallString", 0, REG_SZ, (unsigned char *)name, lstrlen(name));
				RegSetValueEx(hKey, "Publisher", 0, REG_SZ, (unsigned char *)CORPORATION, lstrlen(CORPORATION));
				RegSetValueEx(hKey, "HelpLink", 0, REG_SZ, (unsigned char *)URL, lstrlen(URL));
				RegSetValueEx(hKey, "URLInfoAbout", 0, REG_SZ, (unsigned char *)URL, lstrlen(URL));
				RegCloseKey(hKey);
			}

			if(RegCreateKeyEx(HKEY_CURRENT_USER, CPFSHELL_REG, 0, "" , REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, &dw) == ERROR_SUCCESS) {
				RegSetValueEx(hKey, REG_EXP, 0, REG_DWORD, (BYTE *)&regexp_mode, sizeof(DWORD));
				RegCloseKey(hKey);
			}
			lstrcpy(name, "CXg[I܂B\nExplorer Ńt@CtH_ENbNăj[\A");
			if(regexp_mode) {
				lstrcat(name, "K\");
			} else {
				lstrcat(name, "ChJ[h");
			}
			if(CheckWindows7()) {
				lstrcat(name, "ꊇRs[(W)");
			} else {
				lstrcat(name, "ꊇIERs[(W)");
			}
			lstrcat(name, "I cpfShell ̃_CAO\܂B\nwv͂̏Ԃ F1 L[ĂB");
			if(CheckWindows7()) {
				lstrcat(name, "\nWindows7 ł̓t@C̑I@\͓삵܂̂łӂB");
			}
			MessageBox(hDlg, name, "cpfShell CXg[", MB_OK);
			return TRUE;
		} else {
			MessageBox(hDlg, "CXg[ł܂łB\nNT/2000/XP/Vista/7 ̏ꍇAAdministrator [U[ŃOCĎsĂB", "cpfShell CXg[", MB_OK | MB_ICONERROR);
		}
	} else {
		HKEY hKey;

		if(RegOpenKeyEx(HKEY_CURRENT_USER, CPFSHELL_REG, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS) {
			RegCloseKey(hKey);
			MessageBox(hDlg, "t@C쐬ł܂łB\nł cpfShell CXg[ĂꍇAExplorer ̃EChESďIĂēxsĂ݂ĂB\n܂ANT/2000/XP/Vista/7 ̏ꍇAAdministrator [U[ŃOCĎsĂB", "cpfShell CXg[", MB_OK | MB_ICONERROR);
		} else {
			MessageBox(hDlg, "t@C쐬ł܂łB\nNT/2000/XP/Vista/7 ̏ꍇAAdministrator [U[ŃOCĎsĂB", "cpfShell CXg[", MB_OK | MB_ICONERROR);
		}
	}
	return FALSE;
}
