#pragma warning (disable: 4786)

#include <windows.h>
#include <comdef.h>
#import "vbscript.tlb" no_namespace named_guids 
#include "cpfsub.h"

using namespace std;

//
//	K\
//
BOOL RegularExp(string pattern, string name)
{
	// CX^X
	IRegExpPtr pReg;
	if(FAILED(pReg.CreateInstance(CLSID_RegExp))) {
		return FALSE;
	}
	_bstr_t bpattern(pattern.c_str());
	_bstr_t bname(name.c_str());
	BOOL flag = FALSE;
	// SΏۂ
	pReg->put_Global(VARIANT_TRUE);
	// p^[Zbg
	pReg->put_Pattern(bpattern);
	try {
		// s
		if(pReg->Test(bname) == VARIANT_TRUE) {
			flag = TRUE;
		}
	} catch(...) {
	}
	pReg.Release();
	return flag;
}

BOOL StrMatch(string pattern, string name)
{
	if(pattern.empty()) {
		return name.empty();
	} else if(pattern[0] == '*') {
		return StrMatch(pattern.substr(1), name) || (!name.empty() && StrMatch(pattern, name.substr(1)));
	} else if(pattern[0] == '?') {
		return !name.empty() && StrMatch(pattern.substr(1), name.substr(1));
	} else {
		return (toupper(pattern[0]) == toupper(name[0])) && StrMatch(pattern.substr(1), name.substr(1));
	}
}

//
//	ChJ[h
//
BOOL WildCard(string pattern, string name, int regexp_mode)
{
	if(regexp_mode) {
		return RegularExp(pattern, name);
	} else {
		vector<string> list;
		Split(list, pattern, string("\t "));

		for(vector<string>::iterator str = list.begin() ; str != list.end() ; str++) {
			string pat;
			if(!str->empty()) {
				pat = *str;
				if(str->at(0) == '.') {
					pat = "*" + *str;
				}
				if(pat.find('.') == string::npos) {
					if(StrMatch(pat, name)) {
						return TRUE;
					}
					pat += ".*";
				}
				if(pat.rfind('.') == pat.size() - 1) {
					pat = pat.substr(0, pat.size() - 1);
					if(StrMatch(pat, name) && name.find('.') == string::npos) {
						return TRUE;
					}
				} else {
					if(StrMatch(pat, name)) {
						return TRUE;
					}
				}
			}
		}
	}
	return FALSE;
}

//
//	(Shift-JIS) 1byte ڂH
//
int iskanji(unsigned char ch)
{
	if(((ch >= 0x81) && (ch <= 0x9f)) || ((ch >= 0xe0) && (ch <= 0xfc))) {
		return TRUE;
	}
	return FALSE;
}

//
//	tH_̎o
//
std::string ExtractDirectory(std::string path, bool flag)
{
	std::string::size_type pos;
	std::string dir = path;

	pos = path.size();
	while(pos != std::string::npos) {
		pos = path.rfind('\\', pos);
		if(pos > 0) {
			if(!iskanji(static_cast<unsigned char>(path[pos - 1]))) {
				dir = path.substr(0, pos);
				break;
			}
			pos--;
		}
	}
	if(flag && dir.size() == 2 && dir[1] == ':') {
		dir += "\\";
	}
	return dir;
}

//
//	fBNg \ 폜
//
std::string DeleteYen(std::string path)
{
	std::string::size_type len;
	len = path.size();
	if(len > 1) {
		if(path[len - 1] == '\\' && !iskanji(static_cast<unsigned char>(path[len - 2]))) {
			return path.substr(0, len - 1);
		}
	}
	return path;
}

//
//	t@C̎o
//
std::string ExtractFilename(std::string path)
{
	std::string::size_type pos;
	std::string name;

	pos = path.size();
	while(pos != std::string::npos) {
		pos = path.rfind('\\', pos);
		if(pos > 0 && pos < path.size() - 1) {
			if(!iskanji(static_cast<unsigned char>(path[pos - 1]))) {
				name = path.substr(pos + 1);
				break;
			}
			pos--;
		} else {
			break;
		}
	}
	return name;
}

//
//	gq̎o
//
std::string ExtractExt(string path, int regexp_mode)
{
	std::string ext;
	std::string::size_type pos;

	pos = path.rfind('.');
	if(pos != std::string::npos) {
		if(regexp_mode) {
			ext = "\\" + path.substr(pos) + "$";
		} else {
			ext = "*" + path.substr(pos);
		}
	}
	return ext;
}

//
//	WindowsXP ȍ~ǂ
//
BOOL CheckWindowsXP()
{
    OSVERSIONINFO osvi;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if((osvi.dwMajorVersion == 5 && osvi.dwMinorVersion >= 1) || osvi.dwMajorVersion > 5) {
			return TRUE;
		}
	}
	return FALSE;
}

//
//	WindowsVista ȍ~ǂ
//
BOOL CheckWindowsVista()
{
    OSVERSIONINFO osvi;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if(osvi.dwMajorVersion >= 6) {
			return TRUE;
		}
	}
	return FALSE;
}

//
//	Windows7 ȍ~ǂ
//
BOOL CheckWindows7()
{
    OSVERSIONINFO osvi;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if((osvi.dwMajorVersion == 6 && osvi.dwMinorVersion >= 1) || osvi.dwMajorVersion > 6) {
			return TRUE;
		}
	}
	return FALSE;
}

//
//	tH_Cɍ쐬
//
void ForceDirectories(std::string path)
{
	std::string::size_type pos;
	std::string dir;

	pos = path.find('\\');
	while(pos != std::string::npos) {
		if(pos > 0) {
			if(!iskanji(static_cast<unsigned char>(path[pos - 1]))) {
				dir = path.substr(0, pos);
				CreateDirectory(dir.c_str(), NULL);
			}
		}
		pos = path.find('\\', pos + 1);
	}
	CreateDirectory(path.c_str(), NULL);
}

//
//	eEChE̒Ɉړ
//
void CenterParentWindow(HWND wnd)
{
	int x, y;
	RECT rc, prc;
	HWND pwnd = GetParent(wnd);

	if(pwnd != NULL) {
		GetWindowRect(wnd, &rc);
		GetWindowRect(pwnd, &prc);
		x = prc.left + ((prc.right - prc.left) / 2) - ((rc.right - rc.left) / 2);
		y = prc.top + ((prc.bottom - prc.top) / 2) - ((rc.bottom - rc.top) / 2);
		SystemParametersInfo(SPI_GETWORKAREA, 0, &prc, 0);
		if(x < 0) {
			x = 0;
		}
		if(y < 0) {
			y = 0;
		}
		if(x > prc.right - (rc.right - rc.left)) {
			x = prc.right - (rc.right - rc.left);
		}
		if(y > prc.bottom - (rc.bottom - rc.top)) {
			y = prc.bottom - (rc.bottom - rc.top);
		}
		SetWindowPos(wnd, NULL, x, y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
	}
}

//
//	}EXJ[\ʒuɈړ
//
void MouseCursorWindow(HWND wnd, int id)
{
	POINT point;
	RECT rc, crc;
	HWND cwnd;

	GetCursorPos(&point);
	GetWindowRect(wnd, &rc);
	cwnd = GetDlgItem(wnd, id);
	if(cwnd != NULL) {
		GetWindowRect(cwnd, &crc);
		point.x -= (crc.left - rc.left) + (crc.right - crc.left) / 2;
		point.y -= (crc.top - rc.top) + (crc.bottom - crc.top) / 2;
	} else {
		point.x -= (rc.right - rc.left) / 2;
		point.y -= (rc.bottom - rc.top) / 2;
	}
	if(point.x < 0) {
		point.x = 0;
	}
	if(point.y < 0) {
		point.y = 0;
	}
	SystemParametersInfo(SPI_GETWORKAREA, 0, &crc, 0);
	if(point.x > crc.right - (rc.right - rc.left)) {
		point.x = crc.right - (rc.right - rc.left);
	}
	if(point.y > crc.bottom - (rc.bottom - rc.top)) {
		point.y = crc.bottom - (rc.bottom - rc.top);
	}
	SetWindowPos(wnd, 0, point.x, point.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}
